﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SelfHostWebGet
{
    [DataContract(Name = "Product", Namespace = "")]
    public class Product : EntityBase
    {
        public Product()
        {
            QuantityPerUnit = string.Empty;
        }

        private int _productId;
        [DataMember]
        public int ProductId
        {
            get { return _productId; }
            set
            {
                _productId = value;
                PropertyChangedHandler("ProductId");
            }
        }

        private string _productName;
        [DataMember]
        public string ProductName
        {
            get { return _productName; }
            set
            {
                _productName = value;
                PropertyChangedHandler("ProductName");
            }
        }

        private string _quantityPerUnit;
        [DataMember]
        public string QuantityPerUnit
        {
            get { return _quantityPerUnit; }
            set
            {
                _quantityPerUnit = value;
                PropertyChangedHandler("QuantityPerUnit");
            }
        }

        private decimal _unitPrice;
        [DataMember]
        public decimal UnitPrice
        {
            get { return _unitPrice; }
            set
            {
                _unitPrice = value;
                PropertyChangedHandler("UnitPrice");
            }
        }

        private int _unitsInStock;
        [DataMember]
        public int UnitsInStock
        {
            get { return _unitsInStock; }
            set
            {
                _unitsInStock = value;
                PropertyChangedHandler("UnitsInStock");
            }
        }

        private int _unitsOnOrder;
        [DataMember]
        public int UnitsOnOrder
        {
            get { return _unitsOnOrder; }
            set
            {
                _unitsOnOrder = value;
                PropertyChangedHandler("UnitsOnOrder");
            }
        }

        private int _reorderLevel;
        [DataMember]
        public int ReorderLevel
        {
            get { return _reorderLevel; }
            set
            {
                _reorderLevel = value;
                PropertyChangedHandler("ReorderLevel");
            }
        }

        private bool _discontinued;
        [DataMember]
        public bool Discontinued
        {
            get { return _discontinued; }
            set
            {
                _discontinued = value;
                PropertyChangedHandler("Discontinued");
            }
        }

        private DateTime _discontinuedDate;
        [DataMember]
        public DateTime DiscontinuedDate
        {
            get { return _discontinuedDate; }
            set
            {
                _discontinuedDate = value;
                PropertyChangedHandler("DiscontinuedDate");
            }
        }
    }
}
