﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Net;
using System.ServiceModel.Web;

namespace SelfHostWebGet
{
    public class SelfHostedSoapBasedServices : 
        ServiceContracts.IPolicy, 
        ServiceContracts.IEcho,
        ServiceContracts.IRestFulCustomer
    {
        public Stream GetSilverlightPolicy()
        {
            return new ClientPolicyFile().GetClientAccessPolicy();
        }

        public Stream GetCrossDomain()
        {
            return new ClientPolicyFile().GetCrossDomain();
        }

        public string Echo(string text)
        {
            return string.Format("Hello, {0}", text);
        }

        public Customer GetCustomer(string id)
        {
            var customer = new Customer() { Name = "Lukas" };

            // Get customer from database

            return customer;
        }

        public void PutCustomer(Customer customer)
        {
            //Console.WriteLine("Put customer in database");
            
        }

        public void DeleteCustomer(string id)
        {
            // Delete customer in database
        }

        // Examples will demonstrate:
        // Action: GET  (1)
        // Response: XML vs JSON (2)
        // Parameter: Its own Segment vs Parenthesis vs Default Parameter (3)
        // Pass string vs entity (2)
        // Status Codes (1)
        // Caching (1)
        // Action: POST (1)
        // Request: XML vs JSON (2)

        private List<Product> ProductList
        {
            get
            {
                return new List<Product>
                           {
                               new Product {ProductId = 1001, ProductName = "Foo", UnitPrice = (decimal) 19.99},
                               new Product {ProductId = 1013, ProductName = "Voo", UnitPrice = (decimal) 11.99},
                               new Product {ProductId = 1014, ProductName = "Woo", UnitPrice = (decimal) 13.99},
                               new Product {ProductId = 1015, ProductName = "Xoo", UnitPrice = (decimal) 39.99},
                               new Product {ProductId = 1016, ProductName = "Yoo", UnitPrice = (decimal) 59.99},
                               new Product {ProductId = 1016, ProductName = "Boo", UnitPrice = (decimal) 9.99},
                               new Product {ProductId = 1016, ProductName = "Coo", UnitPrice = (decimal) 4.99},
                               new Product {ProductId = 1016, ProductName = "Doo", UnitPrice = (decimal) 13.99},
                               new Product {ProductId = 1002, ProductName = "Goo", UnitPrice = (decimal) 49.99},
                               new Product {ProductId = 1007, ProductName = "Noo", UnitPrice = (decimal) 79.99},
                               new Product {ProductId = 1008, ProductName = "Ooo", UnitPrice = (decimal) 49.99},
                               new Product {ProductId = 1009, ProductName = "Qoo", UnitPrice = (decimal) 29.99},
                               new Product {ProductId = 1010, ProductName = "Roo", UnitPrice = (decimal) 119.99},
                               new Product {ProductId = 1003, ProductName = "Hoo", UnitPrice = (decimal) 109.99},
                               new Product {ProductId = 1004, ProductName = "Koo", UnitPrice = (decimal) 99.99},
                               new Product {ProductId = 1005, ProductName = "Loo", UnitPrice = (decimal) 1.99},
                               new Product {ProductId = 1006, ProductName = "Moo", UnitPrice = (decimal) 2.99},
                               new Product {ProductId = 1011, ProductName = "Soo", UnitPrice = (decimal) 4.99},
                               new Product {ProductId = 1012, ProductName = "Too", UnitPrice = (decimal) 24.99},
                               new Product {ProductId = 1017, ProductName = "Zoo", UnitPrice = (decimal) 0.99}
                           };
            }
        }


        // # 1
        public Product FindProduct1(string productIdString)
        {
            int productId = int.Parse(productIdString);
            var query = from p in ProductList
                        where p.ProductId == productId
                        select p;
            Product product = query.FirstOrDefault() as Product;
            return product;
        }

        // # 2
        public Product FindProduct2(string productIdString)
        {
            int productId = int.Parse(productIdString);
            var query = from p in ProductList
                        where p.ProductId == productId
                        select p;
            Product product = query.FirstOrDefault() as Product;
            return product;
        }

        // # 3
        public Product FindProduct3(string productIdString)
        {
            if (productIdString.Length == 0)
            {
                WebOperationContext.Current.OutgoingResponse.StatusCode = HttpStatusCode.BadRequest;
                return null;
            }

            int productId = int.Parse(productIdString);
            var query = from p in ProductList
                        where p.ProductId == productId
                        select p;
            Product product = query.FirstOrDefault() as Product;
            WebOperationContext.Current.OutgoingResponse.StatusCode = HttpStatusCode.OK;
            return product;
}

        // # 4
        public Product FindProductByNameAsXml(string productName)
        {
            return FindProductByName(productName);
        }

        // # 5
        public Product FindProductByNameAsJson(string productName)
        {
            return FindProductByName(productName);
        }

        private Product FindProductByName(string productName)
        {
            var query = from p in ProductList
                        where p.ProductName == productName
                        select p;
            Product product = query.FirstOrDefault() as Product;
            return product;
        }

        // # 6
        public List<Product> FindProductListAsXml(string countString, string maxPriceString)
        {
            return FindProductList(countString, maxPriceString);
        }

        // # 7
        public List<Product> FindProductListAsJson(string countString, string maxPriceString)
        {
            return FindProductList(countString, maxPriceString);
        }

        private List<Product> FindProductList(string countString, string maxPriceString)
        {
            int count = int.Parse(countString);
            decimal maxPrice = int.Parse(maxPriceString);
            var query = (from p in ProductList
                         where p.UnitPrice <= maxPrice
                         orderby p.UnitPrice ascending
                         select p).Take(count);
            List<Product> filtererdProducts = query.ToList();
            return filtererdProducts;
        }
        
        //  # 999
        public Product FindProduct8(string productIdString)
        {
            int productId = int.Parse(productIdString);
            var query = from p in ProductList
                        where p.ProductId == productId
                        select p;
            Product product = query.FirstOrDefault() as Product;
            return product;
        }
        
        // # 9
        public void AddProductAsJson(Product product)
        {
            AddProduct(product);
        }

        // # 10
        public void AddProductAsXml(Product product)
        {
            AddProduct(product);
        }

        private void AddProduct(Product product)
        {
            var query = @"INSERT INTO Products (ProductId, ProductName, UnitPrice) VALUES (@productId, @productName, @unitPrice) ";

            const string connString = @"Data Source=(local)\SQLEXPRESS;Initial Catalog=NorthwindEF;Integrated Security=True;";

            using (var conn = new SqlConnection(connString))
            {
                using (var cmd = new SqlCommand(query, conn))
                {
                    cmd.Parameters.AddWithValue("@productId", product.ProductId);
                    cmd.Parameters.AddWithValue("@productName", product.ProductName);
                    cmd.Parameters.AddWithValue("@unitPrice", product.UnitPrice);
                    //conn.Open();
                    //cmd.ExecuteNonQuery();
                }
            }
        }
    }
}
